#define _WIN32_DCOM
#include "ptrISomme.h"
#include "../../Commun/Commun/Somme_h.h"
#include <string>
using std::wstring;

ptrISomme::ptrISomme(const wstring &adresse)
   : ptr_(0)
{
   const int NBITF_VOULUES = 1,
             ITF_ISOMME    = 0;
   MULTI_QI Interfaces[NBITF_VOULUES] =
   {
      { &IID_ISomme,  0, S_OK }
   };
   COSERVERINFO ServeurVoulu =
   {
      0,  const_cast<wchar_t*>(adresse.c_str()), 0, 0
   };
   HRESULT hr =
      CoCreateInstanceEx(CLSID_CoSommateur, // fabrique voulue
                         0, // != 0 seulement pour un agrgat
                         CLSCTX_LOCAL_SERVER, // contexte prfr de serveur
                         &ServeurVoulu, // le COSERVERINFO
                         NBITF_VOULUES, // nb. Elments du tableau ItfDemandees
                         Interfaces); // MULTI_QI[]
   if (FAILED(hr) || FAILED(Interfaces[ITF_ISOMME].hr))
      throw ErreurCreation();
   ptr_ = static_cast<ISomme*>(Interfaces[ITF_ISOMME].pItf);
}
ptrISomme::ptrISomme(const ptrISomme &p)
   : ptr_(p.ptr_)
{
   if (ptr_) ptr_->AddRef();
}

#include <utility>
void ptrISomme::swap(ptrISomme &p)
   { std::swap(ptr_, p.ptr_); }

ptrISomme& ptrISomme::operator=(const ptrISomme &p)
{
   ptrISomme(p).swap(*this);
   return *this;
}
ptrISomme::~ptrISomme() throw()
   { if (ptr_) ptr_->Release(); }

int ptrISomme::Somme(const int x, const int y)
{
   if (!ptr_)
      throw ErreurInvocation();
   int resultat;
   HRESULT hr = ptr_->Somme(x, y, &resultat);
   if (FAILED(hr))
      throw ErreurInvocation();
   return resultat;
}
