// Fichier ConversionChaines.cpp

#include "ConversionChaines.h"
#include <string>
using std::basic_string;
using std::string;
using std::wstring;
#include <algorithm>
using std::transform;
#include <locale>
using std::locale;

template <class CDest, class CSrc>
   basic_string<CDest> rebuild(const basic_string<CSrc> &s)
      { return basic_string<CDest>(s.begin(), s.end()); }

wstring StringToWString(const string &s)
   { return rebuild<wstring::value_type>(s) ; }

string WStringToString(const wstring &s)
   { return rebuild<string::value_type>(s) ; }

template <class C>
   class ConvertirMajuscules
   {
      const locale &loc_;
   public:
      ConvertirMajuscules(const locale &loc = locale(""))
         : loc_(loc)
      {
      }
      C operator()(const C c)
         { return toupper(c, loc_); }
   };

template <class C>
   basic_string<C> Majuscules_(const basic_string<C> &s)
   {
      basic_string<C> resultat(s.size(), C());
      transform(s.begin(), s.end(), resultat.begin(), ConvertirMajuscules<C>());
      return resultat;
   }

// Retourne la version majuscule du texte en paramtre
string Majuscules(const string &s)
   { return Majuscules_(s); }
