#define _WIN32_DCOM
// Fichier: ServeurSomme.cpp

#include "FabriqueSomme.h"
#include "Registry.h" // RegisterServer(), UnregisterServer()
#include "ConversionChaines.h"
#include "ChargeurCOM.h"
#include "GestionnaireDeVerrou.h"
#include "../../Commun/Commun/Somme_h.h"
#include <string>
using std::string;
#include <iostream>
using std::cout;
using std::cerr;
using std::endl;

void LancerContexte();
void FermerContexte();

int main(int argc, char *argv[])
{
   if (argc == 2)
   {
      static const string
         PREFIXE_WIN = "/", PREFIXE_UNIX = "-",
         PARAM = Majuscules(argv[1]),
         ENREGISTRER = Majuscules("RegServer"),
         DESENREGISTRER = Majuscules("UnregServer"),
         LANCEMENTCOM= Majuscules("Embedding");
      if (PARAM == PREFIXE_WIN  + ENREGISTRER ||
          PARAM == PREFIXE_UNIX + ENREGISTRER)
      {
         HRESULT hr = RegisterServer
            (argv[0], CLSID_CoSommateur,
             "Composant externe dmonstrateur",
             "Composant.Somme.Externe",
             "Composant.Somme.Externe.1",
             0 );
         if (SUCCEEDED(hr))
            cout << "Inscription russie de " << argv[0]<< endl;
         else
            cerr << "chec  l'inscription de " << argv[0]<< " code " << hr << endl;
         return hr;
      }
      else if (PARAM == PREFIXE_WIN  + DESENREGISTRER ||
               PARAM == PREFIXE_UNIX + DESENREGISTRER)
      {
         HRESULT hr = UnregisterServer
            (CLSID_CoSommateur,
             "Composant.Somme.Externe",
             "Composant.Somme.Externe.1");
         if (SUCCEEDED(hr))
            cout << "Dsinscription russie de " << argv[0]<< endl;
         else
            cerr << "chec  la dsinscription de " << argv[0]<< " code " << hr << endl;
         return hr;
      }
      else if (PARAM == PREFIXE_WIN  + LANCEMENTCOM ||
               PARAM == PREFIXE_UNIX + LANCEMENTCOM)
      {
         ChargeurCOM cc((ChargeurCOM::MultiThreaded()));
         LancerContexte();
         GestionnaireDeVerrou::get().attendre_fin();
         FermerContexte();
      }
      else
         cerr << "Paramtre invalide: " << PARAM << endl;
   }
   else
      cerr << "Nombre de paramtre invalides: " << argc << endl;
}


namespace // localiser les globales
{
   DWORD Jeton = 0;
   IClassFactory *pFab = 0;
}
void LancerContexte ()
{
   ::pFab = new FabriqueSomme;
   CoRegisterClassObject
       (CLSID_CoSommateur, ::pFab,
        CLSCTX_SERVER, REGCLS_MULTIPLEUSE |
                      REGCLS_SUSPENDED, &::Jeton);
   CoResumeClassObjects();
}
void FermerContexte()
{
   CoRevokeClassObject(::Jeton);
   ::pFab->Release();
}
