class Incopiable
{
   Incopiable(const Incopiable&);
   void operator=(const Incopiable&);
protected:
   Incopiable() throw()
      {}
   ~Incopiable() throw()
      {}
};

template <class InitOp, class FinalOp>
   class scope_control
   {
      InitOp init_op_;
      FinalOp final_op_;
   public:
      scope_control(InitOp init_op, FinalOp final_op)
         : init_op_(init_op), final_op_(final_op)
      {
         init_op_();
      }
      ~scope_control() throw() // hopefully
         { final_op_(); }
   };

template <class T, class FinalOp>
   class scoped_handle
   {
      FinalOp final_op_;
      T &value_;
   public:
      typedef T value_type;
      scoped_handle(T &value, FinalOp final_op = FinalOp())
         : value_(value), final_op_(final_op)
      {
      }
      ~scoped_handle() throw() // hopefully
         { final_op_(value_); }
   };

struct Meurs
{
   template <class T>
      void operator()(T p) throw()
         { delete p; }
};

struct MeursTableau
{
   template <class T>
      void operator()(T p) throw()
         { delete[] p; }
};

#include <algorithm>
using std::fill;

#include <iostream>
using std::cout;
using std::endl;

void MessageDebut()
   { cout << "Debut" << endl; }
void MessageFin()
   { cout << "Fin" << endl; }

#include <functional>
using std::unary_function;
using std::binary_function;

template <class>
   struct nullary_function_traits;
template <>
   struct nullary_function_traits<class R(*)()>
      : unary_function<void, R>
   {
      typedef R result_type;
   };
template <class T>
   struct nullary_function_traits
      : unary_function<void, T>
   {
   };

template <class T>
   struct nullary_function
      : unary_function<void, T>
   {
   };

#define _WIN32_DCOM
#include <windows.h>

int main()
{
   class coinit
   {
      unsigned long param_;
   public:
      coinit(unsigned long param)
         : param_(param)
      {
      }
      HRESULT operator()() const
         { return CoInitializeEx(0, param_); }
   };
   scope_control<void (*)(), void (*)()> sc0(MessageDebut, MessageFin);
   scope_control<coinit,void(__stdcall*)()> sc1(coinit(COINIT_APARTMENTTHREADED), CoUninitialize);
   int *p0 = new int(3);
   scoped_handle<int*, Meurs> s0(p0);
   int *p1 = new int[3];
   fill(p1, p1 + 3, -2);
   scoped_handle<int *, MeursTableau> s1(p1);
}
